Entity/Event.php
<?php

declare(strict_types=1);

/*
 * This file is part of the BkstgScheduleBundle package.
 * (c) Luke Bainbridge <http://www.lukebainbridge.ca/>
 * For the full copyright and license information, please view the LICENSE
 * file that was distributed with this source code.
 */

namespace Bkstg\ScheduleBundle\Entity;

use Bkstg\CoreBundle\Entity\Production;
use Bkstg\CoreBundle\Model\PublishableInterface;
use Doctrine\Common\Collections\ArrayCollection;
use MidnightLuke\GroupSecurityBundle\Model\GroupableInterface;
use MidnightLuke\GroupSecurityBundle\Model\GroupInterface;

class Event implements GroupableInterface, PublishableInterface
{
    private $id;
    private $start;
    private $end;
    private $name;
    private $description;
    private $location;
    private $created;
    private $updated;
    private $author;
    private $groups;
    private $invitations;
    private $colour;
    private $full_company;
    private $active;
    private $published;
    private $schedule;

    /**
     * Create a new event.
     */
    public function __construct()
    {
        $this->groups = new ArrayCollection();
        $this->invitations = new ArrayCollection();
    }

    /**
     * Get id.
     *
     * @return int
     */
    public function getId(): int
    {
        return $this->id;
    }

    /**
     * Set start.
     *
     * @param \DateTime $start The start date.
     *
     * @return Event
     */
    public function setStart(\DateTime $start): self
    {
        $this->start = $start;

        return $this;
    }

    /**
     * Get start.
     *
     * @return \DateTime
     */
    public function getStart(): \DateTime
    {
        return $this->start;
    }

    /**
     * Set end.
     *
     * @param \DateTime $end The end date.
     *
     * @return Event
     */
    public function setEnd(\DateTime $end): self
    {
        $this->end = $end;

        return $this;
    }

    /**
     * Get end.
     *
     * @return \DateTime
     */
    public function getEnd(): \DateTime
    {
        return $this->end;
    }

    /**
     * Set name.
     *
     * @param string $name The event name.
     *
     * @return Event
     */
    public function setName(string $name): self
    {
        $this->name = $name;

        return $this;
    }

    /**
     * Get name.
     *
     * @return string
     */
    public function getName(): ?string
    {
        return $this->name;
    }

    /**
     * Set description.
     *
     * @param string|null $description The description.
     *
     * @return Event
     */
    public function setDescription(string $description = null): self
    {
        $this->description = $description;

        return $this;
    }

    /**
     * Get description.
     *
     * @return string|null
     */
    public function getDescription(): ?string
    {
        return $this->description;
    }

    /**
     * Set location.
     *
     * @param string|null $location The location.
     *
     * @return Event
     */
    public function setLocation(string $location = null): self
    {
        $this->location = $location;

        return $this;
    }

    /**
     * Get location.
     *
     * @return string|null
     */
    public function getLocation(): ?string
    {
        return $this->location;
    }

    /**
     * Set created.
     *
     * @param \DateTime $created The created time.
     *
     * @return Event
     */
    public function setCreated(\DateTime $created): self
    {
        $this->created = $created;

        return $this;
    }

    /**
     * Get created.
     *
     * @return \DateTime
     */
    public function getCreated(): \DateTime
    {
        return $this->created;
    }

    /**
     * Set updated.
     *
     * @param \DateTime $updated The updated time.
     *
     * @return Event
     */
    public function setUpdated(\DateTime $updated): self
    {
        $this->updated = $updated;

        return $this;
    }

    /**
     * Get updated.
     *
     * @return \DateTime
     */
    public function getUpdated(): \DateTime
    {
        return $this->updated;
    }

    /**
     * Set author.
     *
     * @param string $author The author.
     *
     * @return Event
     */
    public function setAuthor(string $author): self
    {
        $this->author = $author;

        return $this;
    }

    /**
     * Get author.
     *
     * @return string
     */
    public function getAuthor(): string
    {
        return $this->author;
    }

    /**
     * Add group.
     *
     * @param Production $group The production.
     *
     * @return Event
     */
    public function addGroup(GroupInterface $group): self
    {
        if (!$group instanceof Production) {
            throw new Exception('Group type not supported.');
        }
        $this->groups[] = $group;

        return $this;
    }

    /**
     * Remove group.
     *
     * @param Production $group The production.
     *
     * @return bool
     */
    public function removeGroup(GroupInterface $group): bool
    {
        return $this->groups->removeElement($group);
    }

    /**
     * Get groups.
     *
     * @return ArrayCollection
     */
    public function getGroups(): ArrayCollection
    {
        return $this->groups;
    }

    /**
     * {@inheritdoc}
     *
     * @param GroupInterface $group The group to check for.
     *
     * @return bool
     */
    public function hasGroup(GroupInterface $group): bool
    {
        foreach ($this->groups as $my_group) {
            if ($group->isEqualTo($my_group)) {
                return true;
            }
        }

        return false;
    }

    /**
     * Add invitation.
     *
     * @param Invitation $invitation The invitation.
     *
     * @return Event
     */
    public function addInvitation(Invitation $invitation): self
    {
        $invitation->setEvent($this);
        $this->invitations[] = $invitation;

        return $this;
    }

    /**
     * Remove invitation.
     *
     * @param Invitation $invitation The invitation.
     *
     * @return bool
     */
    public function removeInvitation(Invitation $invitation): bool
    {
        return $this->invitations->removeElement($invitation);
    }

    /**
     * Get invitations.
     *
     * @return ArrayCollection
     */
    public function getInvitations(): ArrayCollection
    {
        return $this->invitations;
    }

    /**
     * Set schedule.
     *
     * @param Schedule|null $schedule The schedule.
     *
     * @return Event
     */
    public function setSchedule(Schedule $schedule = null): self
    {
        $this->schedule = $schedule;

        return $this;
    }

    /**
     * Get schedule.
     *
     * @return Schedule|null
     */
    public function getSchedule(): ?Schedule
    {
        return $this->schedule;
    }

    /**
     * Get colour.
     *
     * @return self
     */
    public function getColour(): ?string
    {
        return $this->colour;
    }

    /**
     * Set colour.
     *
     * @param ?string $colour The colour.
     *
     * @return $this
     */
    public function setColour(?string $colour): self
    {
        $this->colour = $colour;

        return $this;
    }

    /**
     * Get full_company.
     *
     * @return bool
     */
    public function getFullCompany(): ?bool
    {
        return $this->full_company;
    }

    /**
     * Set full_company.
     *
     * @param bool $full_company Whether this is a full company call or not.
     *
     * @return $this
     */
    public function setFullCompany(bool $full_company)
    {
        $this->full_company = $full_company;

        return $this;
    }

    /**
     * Get active.
     *
     * @return bool
     */
    public function isActive(): bool
    {
        return true === $this->active;
    }

    /**
     * Set active.
     *
     * @param bool $active Whether this active or not.
     *
     * @return self
     */
    public function setActive(bool $active): self
    {
        $this->active = $active;

        return $this;
    }

    /**
     * Get published.
     *
     * @return bool
     */
    public function isPublished(): bool
    {
        return true === $this->published;
    }

    /**
     * Set published.
     *
     * @param bool $published Whether this is published or not.
     *
     * @return $this
     */
    public function setPublished(bool $published): PublishableInterface
    {
        $this->published = $published;

        return $this;
    }

    /**
     * Return string represenation.
     *
     * @return string
     */
    public function __toString()
    {
        return $this->name;
    }
}

Form/ScheduleType.php
<?php

declare(strict_types=1);

/*
 * This file is part of the BkstgScheduleBundle package.
 * (c) Luke Bainbridge <http://www.lukebainbridge.ca/>
 * For the full copyright and license information, please view the LICENSE
 * file that was distributed with this source code.
 */

namespace Bkstg\ScheduleBundle\Form;

use Bkstg\ScheduleBundle\BkstgScheduleBundle;
use Bkstg\ScheduleBundle\Entity\Schedule;
use FOS\CKEditorBundle\Form\Type\CKEditorType;
use Symfony\Component\Form\AbstractType;
use Symfony\Component\Form\ChoiceList\Loader\CallbackChoiceLoader;
use Symfony\Component\Form\Extension\Core\Type\ChoiceType;
use Symfony\Component\Form\Extension\Core\Type\CollectionType;
use Symfony\Component\Form\FormBuilderInterface;
use Symfony\Component\OptionsResolver\OptionsResolver;

class ScheduleType extends AbstractType
{
    /**
     * {@inheritdoc}
     *
     * @param FormBuilderInterface $builder The form builder.
     * @param array                $options The options for this form.
     *
     * @return void
     */
    public function buildForm(FormBuilderInterface $builder, array $options): void
    {
        $schedule = $options['data'];
        $builder
            ->add('name', null, [
                'label' => 'schedule.form.name',
            ])
            ->add('location', null, [
                'label' => 'schedule.form.location',
            ])
            ->add('description', CKEditorType::class, [
                'label' => 'schedule.form.description',
                'config' => ['toolbar' => 'basic'],
                'required' => false, ])
            ->add('colour', ChoiceType::class, [
                'label' => 'schedule.form.colour',
                'required' => false,
                'choices' => [
                    'schedule.form.colour_choices.red' => 'important',
                    'schedule.form.colour_choices.green' => 'success',
                    'schedule.form.colour_choices.yellow' => 'warning',
                    'schedule.form.colour_choices.blue' => 'info',
                    'schedule.form.colour_choices.dark' => 'inverse',
                    'schedule.form.colour_choices.purple' => 'special',
                ],
            ])
            ->add('active', ChoiceType::class, [
                // Show "unpublished" instead of active.
                'choice_loader' => new CallbackChoiceLoader(function () use ($schedule) {
                    yield 'schedule.form.status_choices.active' => true;
                    if (!$schedule->isPublished()) {
                        yield 'schedule.form.status_choices.unpublished' => false;
                    } else {
                        yield 'schedule.form.status_choices.archived' => false;
                    }
                }),
                'label' => 'schedule.form.status',
            ])
            ->add('events', CollectionType::class, [
                'label' => 'schedule.form.events',
                'entry_type' => ScheduleEventType::class,
                'entry_options' => ['label' => false],
                'allow_add' => true,
                'allow_delete' => true,
                'by_reference' => false,
            ])
        ;
    }

    /**
     * Set default options.
     *
     * @param OptionsResolver $resolver The options resolver.
     *
     * @return void
     */
    public function configureOptions(OptionsResolver $resolver): void
    {
        $resolver->setDefaults([
            'data_class' => Schedule::class,
            'translation_domain' => BkstgScheduleBundle::TRANSLATION_DOMAIN,
        ]);
    }
}

Resources/views/Schedule/_actions.html.twig
{% trans_default_domain 'BkstgScheduleBundle' %}

{% if is_granted('edit', schedule) %}
  {% set route = app.request.attributes.get('_route') %}
  <ul class="nav nav-tabs mb-3">
    <li class="nav-item">
      <a class="nav-link{% if route == 'bkstg_schedule_read' %} active{% endif %}" href="{{ url('bkstg_schedule_read', {'id': schedule.id, 'production_slug': production.slug}) }}">{{ 'view'|trans }}</a>
    </li>
    <li class="nav-item">
      <a class="nav-link{% if route == 'bkstg_schedule_update' %} active{% endif %}" href="{{ url('bkstg_schedule_update', {'id': schedule.id, 'production_slug': production.slug}) }}">{{ 'edit'|trans }}</a>
    </li>
    <li class="nav-item">
      <a class="nav-link{% if route == 'bkstg_schedule_delete' %} active{% endif %} text-danger" href="{{ url('bkstg_schedule_delete', {'id': schedule.id, 'production_slug': production.slug}) }}">{{ 'delete'|trans }}</a>
    </li>
  </ul>
{% endif %}

Resources/views/Schedule/_form.html.twig
{% trans_default_domain 'BkstgScheduleBundle' %}

{{ form_start(form) }}
  <div class="form-row">
    <div class="col-md-2">
      {{ form_row(form.active) }}
    </div>
    <div class="col">
      {{ form_row(form.name) }}
    </div>
  </div>
  {{ form_row(form.location, {'attr': { 'class': 'google-geolocate' }}) }}
  {{ form_widget(form) }}
  <div class="form-group">
    <a href="{{ url('bkstg_calendar_production', { 'production_slug': production.slug }) }}" class="btn btn-secondary">{{ 'cancel'|trans }}</a>
    <button type="submit" class="btn btn-primary">{{ 'save'|trans }}</button>
  </div>
{{ form_end(form) }}

Resources/views/Schedule/_search_result.html.twig
{% embed '@BkstgSearch/Search/_search_result.html.twig' with {'link': url('bkstg_schedule_read', {'production_slug': result.groups[0].slug, 'id': result.id})} %}
  {% trans_default_domain 'BkstgScheduleBundle' %}
  {% block result %}
    <h4><i class="fa fa-list"></i> {{ result }}</h4>
    <p class="text-primary">{{ result.groups[0] }}</p>
    <p class="text-muted">{{ 'event.date_string'|trans({'%start%': result.start|date(full_date), '%end%': result.end|date(full_date)}) }}</p>
    {% if result.description is not empty %}
      <p>{{ result.description|striptags|truncate(300, true)|purify }}</p>
    {% endif %}
  {% endblock %}
{% endembed %}

Resources/views/Schedule/archive.html.twig
{% extends '@BkstgSchedule/layout.html.twig' %}
{% trans_default_domain 'BkstgScheduleBundle' %}
{% set page_title = 'schedule.title'|trans|title %}

{% block content %}
  <div class="alert alert-info">
    {{ 'schedule.archive_info'|trans }}
  </div>

  {# Event and schedule archive links. #}
  <ul class="nav nav-tabs mb-3">
    <li class="nav-item">
      <a class="nav-link active" href="{{ url('bkstg_schedule_archive', {'production_slug': production.slug}) }}">{{ 'schedules'|trans }}</a>
    </li>
    <li class="nav-item">
      <a class="nav-link" href="{{ url('bkstg_event_archive', {'production_slug': production.slug}) }}">{{ 'events'|trans }}</a>
    </li>
  </ul>

  <p><div class="table-responsive">
    <table class="table table-striped">
      <thead>
        <tr>
          <th></th>
          <th>{{ 'schedule.label.name'|trans }}</th>
          <th>{{ 'schedule.label.author'|trans }}</th>
          <th>{{ 'schedule.label.status'|trans }}</th>
          <th>{{ 'schedule.label.updated'|trans }}</th>
        </tr>
      </thead>
      <tbody>
        {% for schedule in schedules %}
          <tr>
            <td>
              <div class="btn-group btn-group-sm">
                <a href="{{ url('bkstg_schedule_update', {'production_slug': production.slug, 'id': schedule.id}) }}" class="btn btn-info"><i class="fa fa-pencil-alt" aria-hidden="true"></i><span class="sr-only">{{ 'edit'|trans }}</span></a>
                <a href="{{ url('bkstg_schedule_delete', {'production_slug': production.slug, 'id': schedule.id}) }}" class="btn btn-danger"><i class="fa fa-trash" aria-hidden="true"></i><span class="sr-only">{{ 'delete'|trans }}</span></a>
              </div>
            </td>
            <td>{{ schedule.name }}</td>
            <td>{{ get_user(schedule.author) }}</td>
            <td>{{ schedule.published == false ? 'schedule.label.status_choices.unpublished'|trans : 'schedule.label.status_choices.archived'|trans }}</td>
            <td>{{ schedule.updated|date(full_date) }}</td>
          </tr>
        {% else %}
          <tr>
            <td colspan="5">{{ 'schedule.archive_no_schedules'|trans }}</td>
          </tr>
        {% endfor %}
      </tbody>
    </table>
  </div></p>
  {{ knp_pagination_render(schedules) }}
{% endblock %}

Resources/views/Schedule/create.html.twig
{% extends '@BkstgSchedule/layout.html.twig' %}
{% trans_default_domain 'BkstgScheduleBundle' %}
{% set page_title = 'schedule.create'|trans %}

{% form_theme form
  '@BkstgSchedule/Invitation/_form.html.twig'
  '@BkstgSchedule/Event/_form-collection.html.twig'
%}
{% block content %}
  {% include '@BkstgSchedule/Schedule/_form.html.twig' %}
{% endblock %}

Resources/views/Schedule/delete.html.twig
{% extends '@BkstgSchedule/layout.html.twig' %}
{% trans_default_domain 'BkstgScheduleBundle' %}
{% set page_title = 'schedule.delete'|trans({'%schedule%': schedule.name }) %}

{% block content %}
  {% include '@BkstgSchedule/Schedule/_actions.html.twig' with { 'schedule': schedule, 'production': production } only %}
  <p>{{ 'schedule.delete_confirm'|trans({ '%schedule%': schedule.name }) }}</p>
  <p>{{ 'schedule.delete_consequences'|trans }}</p>
  <p><strong>{{ 'schedule.delete_no_undo'|trans }}</strong></p>
  {{ form_start(form) }}
    {{ form_widget(form) }}
    <div class="form-group form-inline">
      <a href="{{ url('bkstg_calendar_production', {'production_slug': production.slug}) }}" class="btn btn-outline-secondary mr-2">{{ 'Cancel'|trans }}</a>
      <input type="submit" name="submit" value="{{ 'Delete'|trans }}" class="btn btn-danger">
    </div>
  {{ form_end(form) }}
{% endblock %}

Resources/views/Schedule/read.html.twig
{% extends '@BkstgSchedule/layout.html.twig' %}
{% trans_default_domain 'BkstgScheduleBundle' %}
{% set page_title = schedule.name %}

{% block content %}
  {% include '@BkstgSchedule/Schedule/_actions.html.twig' with { 'schedule': schedule, 'production': production } only %}
  <div class="row">
    <div class="col-md-8">
      {{ schedule.description|purify }}</p>
    </div>
    <div class="col-md-4">
      {% if schedule.location is not empty %}
        <iframe
          width="100%"
          height="250"
          frameborder="0" style="border:0"
          src="https://www.google.com/maps/embed/v1/place?key={{ google_api_key }}
            &q={{ schedule.location|url_encode }}" allowfullscreen>
        </iframe>
      {% endif %}
    </div>
  </div>

  {% if sorted_events[0] is defined %}
    {% set date_day = sorted_events[0].start|date('F j, Y') %}
    <h3>{{ date_day }}</h3>
  {% endif %}
  <p><div class="table-responsive">
    <table class="table table-striped">
      <thead class="thead-dark">
        <tr>
          <th>{{ 'event.time'|trans }}</th>
          <th>{{ 'event.title'|trans }}</th>
          <th>{{ 'event.invitations'|trans }}</th>
          <th>{{ 'event.notes'|trans }}</th>
        </tr>
      </thead>
      <tbody>
        {% for event in sorted_events %}
          {% if date_day != event.start|date('F j, Y') %}
            {% set date_day = event.start|date('F j, Y') %}
                </tbody>
              </table>
            </div></p>
            <h3>{{ date_day }}</h3>
            <p><div class="table-responsive">
              <table class="table table-striped">
                <thead class="thead-dark">
                  <tr>
                    <th>{{ 'event.time'|trans }}</th>
                    <th>{{ 'event.title'|trans }}</th>
                    <th>{{ 'event.invitations'|trans }}</th>
                    <th>{{ 'event.notes'|trans }}</th>
                  </tr>
                </thead>
                <tbody>
          {% endif %}
          <tr>
            <td>{{ event.start|date('g:i a') }} - {{ event.end|date('g:i a') }}</td>
            <td>{{ event.name }}</td>
            <td>
              <ul>
                {% if event.fullCompany %}
                  <li>{% include '@BkstgSchedule/Event/_full-company.html.twig' with { 'event': event } only %}</li>
                {% else %}
                  {% for invitation in event.invitations %}
                    {% set user = get_user(invitation.invitee) %}
                    <li>{% if user == app.user %}<strong>{% endif %}{% include '@BkstgSchedule/Invitation/_show.html.twig' with {'invitation': invitation} only %}{% if user == app.user %}</strong>{% endif %}</li>
                  {% else %}
                    <li><em class="text-muted">{{ 'event.no_invitees'|trans }}</em></li>
                  {% endfor %}
                {% endif %}
              </ul>
            </td>
            <td>{{ event.description|raw }}</td>
          </tr>
        {% else %}
          <tr>
            <td colspan="4">{{ 'schedule.no_events'|trans }}</td>
          </tr>
        {% endfor %}
      </tbody>
    </table>
  </div></p>
{% endblock %}

Resources/views/Schedule/update.html.twig
{% extends '@BkstgSchedule/layout.html.twig' %}
{% trans_default_domain 'BkstgScheduleBundle' %}
{% set page_title = 'schedule.update'|trans({ '%schedule%': schedule.name }) %}

{% form_theme form
  '@BkstgSchedule/Invitation/_form.html.twig'
  '@BkstgSchedule/Event/_form-collection.html.twig'
%}
{% block content %}
  {% include '@BkstgSchedule/Schedule/_actions.html.twig' with { 'schedule': schedule, 'production': production } only %}
  {% include '@BkstgSchedule/Schedule/_form.html.twig' %}
{% endblock %}